package com.pj.project.sys_dict_item;

import cn.dev33.satoken.annotation.SaCheckPermission;
import com.pj.current.satoken.StpUserUtil;
import com.pj.project.sys_dict.SysDict;
import com.pj.project4sp.SP;
import com.pj.utils.sg.AjaxError;
import com.pj.utils.sg.AjaxJson;
import com.pj.utils.so.SoMap;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;


/**
 * Controller: sys_dict_item -- 
 * @author qzyReal 
 */
@RestController
@RequestMapping("/SysDictItem/")
public class SysDictItemController {

	/** 底层 Service 对象 */
	@Autowired
    SysDictItemService sysDictItemService;

	/** 增 */  
	@RequestMapping("add")
	@SaCheckPermission(SysDict.PERMISSION_CODE)
	@Transactional(rollbackFor = Exception.class)
	public AjaxJson add(SysDictItem s){
		sysDictItemService.add(s);
		return AjaxJson.getSuccessData(s);
	}

	/** 删 */  
	@RequestMapping("delete")
	@SaCheckPermission(SysDict.PERMISSION_CODE)
	public AjaxJson delete(String id){
		int line = sysDictItemService.delete(id);
		return AjaxJson.getByLine(line);
	}
	
	/** 删 - 根据id列表 */  
	@RequestMapping("deleteByIds")
	@SaCheckPermission(SysDict.PERMISSION_CODE)
	public AjaxJson deleteByIds(){
		List<Long> ids = SoMap.getRequestSoMap().getListByComma("ids", long.class);
		int line = SP.publicMapper.deleteByIds(SysDictItem.TABLE_NAME, ids);
		return AjaxJson.getByLine(line);
	}
	
	/** 改 */  
	@RequestMapping("update")
	@SaCheckPermission(SysDict.PERMISSION_CODE)
	public AjaxJson update(SysDictItem s){
		int line = sysDictItemService.update(s);
		return AjaxJson.getByLine(line);
	}

	/** 查 - 根据id */  
	@RequestMapping("getById")
	public AjaxJson getById(String id){
		SysDictItem s = sysDictItemService.getById(id);
		return AjaxJson.getSuccessData(s);
	}

	/** 查集合 - 根据条件（参数为空时代表忽略指定条件） */  
	@RequestMapping("getList")
	public AjaxJson getList() {
		SoMap so = SoMap.getRequestSoMap();
		List<SysDictItem> list = sysDictItemService.getList(so.startPage());
		return AjaxJson.getPageData(so.getDataCount(), list);
	}

	/** 改 - 是否可用(0=可用,1=不可用) */
	@RequestMapping("updateStatus")
	@SaCheckPermission(SysDict.PERMISSION_CODE)
	public AjaxJson updateStatus(Long id, int value){
		SP.publicMapper.updateColumnById(SysDictItem.TABLE_NAME, "status", value, id);
		return AjaxJson.getSuccess();
	}
	
	
	
	// ------------------------- 前端接口 -------------------------
	
	
	/** 改 - 不传不改 [G] */
	@RequestMapping("updateByNotNull")
	public AjaxJson updateByNotNull(String id){
		AjaxError.throwBy(true, "如需正常调用此接口，请删除此行代码");
		// 鉴别身份，是否为数据创建者 
		long userId = SP.publicMapper.getColumnByIdToLong(SysDictItem.TABLE_NAME, "user_id", id);
		AjaxError.throwBy(userId != StpUserUtil.getLoginIdAsLong(), "此数据您无权限修改");
		// 开始修改 (请只保留需要修改的字段)
		SoMap so = SoMap.getRequestSoMap();
		so.clearNotIn("id", "dictId", "itemValue", "itemText", "desc", "sort", "status").clearNull().humpToLineCase();	
		int line = SP.publicMapper.updateBySoMapById(SysDictItem.TABLE_NAME, so, id);
		return AjaxJson.getByLine(line);
	}
	
	
	
	
	
	

}
